/* Hello World Example

   This example code is in the Public Domain (or CC0 licensed, at your option.)

   Unless required by applicable law or agreed to in writing, this
   software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
   CONDITIONS OF ANY KIND, either express or implied.
*/
#include <stdio.h>
#include <stdarg.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "esp_system.h"
#include "esp_spi_flash.h"
#include "argb.h"

char buffer[80];
int vspfunc(const char *format, ...) {
   va_list aptr;
   int ret;

   va_start(aptr, format);
   ret = vsprintf(buffer, format, aptr);
   va_end(aptr);

   return(ret);
}

void app_main()
{
    printf("Hello world!\n");

    /* Print chip information */
    esp_chip_info_t chip_info;
    esp_chip_info(&chip_info);
    printf("This is ESP32 chip with %d CPU cores, WiFi%s%s, ",
            chip_info.cores,
            (chip_info.features & CHIP_FEATURE_BT) ? "/BT" : "",
            (chip_info.features & CHIP_FEATURE_BLE) ? "/BLE" : "");

    printf("silicon revision %d, ", chip_info.revision);

    printf("%dMB %s flash\n", spi_flash_get_chip_size() / (1024 * 1024),
            (chip_info.features & CHIP_FEATURE_EMB_FLASH) ? "embedded" : "external");
	uint32_t fgc = 0x5500FFFF;
    uint32_t bgc = 0x00FF0000;
	printf( "fgc: %x\nbgc: %x\n", fgc, bgc);
	
	uint32_t result1 = 0;
	uint32_t result2 = 0;
	uint8_t fg_A = fgc >> 24;
	uint8_t fg_Ai = 255 - fg_A;
	uint8_t fg_R = (fgc & 0x00FF0000) >> 16;
	uint8_t fg_G = (fgc & 0x0000FF00) >> 8;
	uint8_t fg_B = (fgc & 0x000000FF);
	uint8_t bg_R = (bgc & 0x00FF0000) >> 16;
	uint8_t bg_G = (bgc & 0x0000FF00) >> 8;
	uint8_t bg_B = (bgc & 0x000000FF);
	
	uint32_t r_R = ((fg_R*fg_A)+(fg_Ai*bg_R)) >> 8;
	uint32_t r_G = ((fg_G*fg_A)+(fg_Ai*bg_G)) >> 8;
	uint32_t r_B = ((fg_B*fg_A)+(fg_Ai*bg_B)) >> 8;
	
	result2 = (r_R << 16) + (r_G << 8) + r_B;
	printf("fg_A: %x\nfg_Ai: %x\n", fg_A, fg_Ai);
	printf("fg_R: %x\n", fg_R);
	printf("fg_G: %x\n", fg_G);
	printf("fg_B: %x\n", fg_B);
	printf("bg_R: %x\n", bg_R);
	printf("bg_G: %x\n", bg_G);
	printf("bg_B: %x\n", bg_B);
	result1 = cAblendARGB8888_BfBb(fg_A, fg_R, fg_G, fg_B, bg_R, bg_G, bg_B);
    printf("result1: %x\n", result1);
	printf("result2: %x\n", result2);
	
	 for (int i = 10; i >= 0; i--) {
        printf("Restarting in %d seconds...\n", i);
        vTaskDelay(1000 / portTICK_PERIOD_MS);}
    printf("Restarting now.\n");
 //   fflush(stdout);
    esp_restart();
}
